--- old/usr/src/lib/libm/common/R/sincosf.c	2014-05-04 03:06:01.272660023 +0200
+++ new/usr/src/lib/libm/common/R/sincosf.c	2014-05-04 03:06:01.721916661 +0200
@@ -98,6 +98,7 @@
 	double	y, z, w;
 	float	f, g;
 	int	n, ix, hx, hy;
+	volatile int i;
 
 	hx = *((int *)&x);
 	ix = hx & 0x7fffffff;
@@ -107,7 +108,7 @@
 	if (ix <= 0x4016cbe4) {		/* |x| < 3*pi/4 */
 		if (ix <= 0x3f490fdb) {		/* |x| < pi/4 */
 			if (ix <= 0x39800000) {	/* |x| <= 2**-12 */
-				volatile int	i = (int)y;
+				i = (int)y;
 #ifdef lint
 				i = i;
 #endif
--- old/usr/src/lib/libm/common/R/sincospif.c	2014-05-04 03:06:02.804175682 +0200
+++ new/usr/src/lib/libm/common/R/sincospif.c	2014-05-04 03:06:03.027659232 +0200
@@ -31,7 +31,7 @@
 
 #include "libm.h"
 
-void sincospi(double x, double *s, double *c);
+extern void sincospi(double, double *, double *);
 
 void
 sincospif(float x, float *s, float *c) {
--- old/usr/src/lib/libm/common/R/sinf.c	2014-05-04 03:06:04.906657135 +0200
+++ new/usr/src/lib/libm/common/R/sinf.c	2014-05-04 03:06:04.720471958 +0200
@@ -76,6 +76,7 @@
 	double	y, z, w;
 	float	f;
 	int	n, ix, hx, hy;
+	volatile int i;
 
 	hx = *((int *)&x);
 	ix = hx & 0x7fffffff;
@@ -85,7 +86,7 @@
 	if (ix <= 0x4016cbe4) {		/* |x| < 3*pi/4 */
 		if (ix <= 0x3f490fdb) {		/* |x| < pi/4 */
 			if (ix <= 0x39800000) {	/* |x| <= 2**-12 */
-				volatile int	i = (int)y;
+				i = (int)y;
 #ifdef lint
 				i = i;
 #endif
--- old/usr/src/lib/libm/common/R/tanf.c	2014-05-04 03:06:06.819925583 +0200
+++ new/usr/src/lib/libm/common/R/tanf.c	2014-05-04 03:06:06.637138480 +0200
@@ -76,6 +76,7 @@
 	double	y, z, w;
 	float	f;
 	int	n, ix, hx, hy;
+	volatile int i;
 
 	hx = *((int *)&x);
 	ix = hx & 0x7fffffff;
@@ -86,7 +87,7 @@
 		if (ix <= 0x3f490fdb) {		/* |x| < pi/4 */
 			if (ix < 0x3c000000) {		/* |x| < 2**-7 */
 				if (ix <= 0x39800000) {	/* |x| < 2**-12 */
-					volatile int	i = (int)y;
+					i = (int)y;
 #ifdef lint
 					i = i;
 #endif
--- old/usr/src/lib/libm/common/complex/cpow.c	2014-05-04 03:06:08.209148956 +0200
+++ new/usr/src/lib/libm/common/complex/cpow.c	2014-05-04 03:06:08.240261962 +0200
@@ -104,7 +104,7 @@
 	zero = 0.0;
 
 static const int hiinf = 0x7ff00000;
-double atan2pi(double, double);
+extern double atan2pi(double, double);
 
 /*
  * Assuming |t[0]| > |t[1]| and |t[2]| > |t[3]|, sum4fp subroutine
--- old/usr/src/lib/libm/common/complex/k_cexp.c	2014-05-04 03:06:09.385767132 +0200
+++ new/usr/src/lib/libm/common/complex/k_cexp.c	2014-05-04 03:06:09.629214375 +0200
@@ -117,7 +117,7 @@
 
 double
 __k_cexp(double x, int *n) {
-	double hi, lo, c, t;
+	double hi = 0.0L, lo = 0.0L, c, t;
 	int k, xsb;
 	unsigned hx, lx;
 
--- old/usr/src/lib/libm/common/complex/k_clog_rl.c	2014-05-04 03:06:11.355716390 +0200
+++ new/usr/src/lib/libm/common/complex/k_clog_rl.c	2014-05-04 03:06:11.386044700 +0200
@@ -494,7 +494,7 @@
 	if (n > 122 || y == 0.0L) {
 #endif
 
-		XFSCALE(x, 0x3fff - (ix >> 16));
+		XFSCALE(x, (0x3fff - (ix >> 16)));
 		i = ((ix & 0xffff) + 0x100) >> 9;  /* 7.5 bits of x */
 		zk = 1.0L + ((long double) i) * 0.0078125L;
 		z = x - zk;
@@ -517,8 +517,8 @@
 /*
  * compute z = x*x + y*y
  */
-		XFSCALE(x, 0x3fff - (ix >> 16));
-		XFSCALE(y, 0x3fff - n - (iy >> 16));
+		XFSCALE(x, (0x3fff - (ix >> 16)));
+		XFSCALE(y, (0x3fff - n - (iy >> 16)));
 		ix = (ix & 0xffff) | 0x3fff0000;
 		iy = (iy & 0xffff) | (0x3fff0000 - (n << 16));
 		nx -= 0x3fff;
--- old/usr/src/lib/libm/common/m9x/__fex_hdlr.c	2014-05-04 03:06:12.696879693 +0200
+++ new/usr/src/lib/libm/common/m9x/__fex_hdlr.c	2014-05-04 03:06:12.727097764 +0200
@@ -378,7 +378,7 @@
 #define test_sse_hw	1
 #else
 extern int _sse_hw;
-#define test_sse_hw	&_sse_hw && _sse_hw
+#define test_sse_hw	_sse_hw
 #endif
 
 #if !defined(REG_PC)
@@ -394,7 +394,7 @@
 {
 	struct fex_handler_data	*thr_handlers;
 	struct sigaction	act;
-	void			(*handler)(), (*simd_handler[4])();
+	void			(*handler)() = NULL, (*simd_handler[4])();
 	int			mode, simd_mode[4], i, len, accrued, *ap;
 	unsigned int		cwsw, oldcwsw, mxcsr, oldmxcsr;
 	enum fex_exception	e, simd_e[4];
--- old/usr/src/lib/libm/common/m9x/__fex_i386.c	2014-05-04 03:06:14.497288293 +0200
+++ new/usr/src/lib/libm/common/m9x/__fex_i386.c	2014-05-04 03:06:14.525386308 +0200
@@ -1428,6 +1428,9 @@
 		case fex_ldouble:
 			*(float *)ea = (float) r.val.q;
 			break;
+
+		default:
+			break;
 		}
 		if (ex != FPE_FLTRES && (op & 8) != 0)
 			pop(uap);
@@ -1461,6 +1464,9 @@
 		case fex_ldouble:
 			*(int *)ea = (int) r.val.q;
 			break;
+
+		default:
+			break;
 		}
 		if (ex != FPE_FLTRES && (op & 8) != 0)
 			pop(uap);
@@ -1494,6 +1500,9 @@
 		case fex_ldouble:
 			*(double *)ea = (double) r.val.q;
 			break;
+
+		default:
+			break;
 		}
 		if (ex != FPE_FLTRES && (op & 8) != 0)
 			pop(uap);
@@ -1527,6 +1536,9 @@
 		case fex_ldouble:
 			*(short *)ea = (short) r.val.q;
 			break;
+
+		default:
+			break;
 		}
 		if (ex != FPE_FLTRES && (op & 8) != 0)
 			pop(uap);
@@ -1565,6 +1577,9 @@
 		case fex_ldouble:
 			*(long long *)ea = (long long) r.val.q;
 			break;
+
+		default:
+			break;
 		}
 		if (ex != FPE_FLTRES)
 			pop(uap);
@@ -1588,6 +1603,9 @@
 	case fex_double:
 		r.val.q = (long double) r.val.d;
 		break;
+
+	default:
+		break;
 	}
 
 	/* for load instructions, push the result onto the stack */
--- old/usr/src/lib/libm/common/m9x/__fex_sparc.c	2014-05-04 03:06:16.713632756 +0200
+++ new/usr/src/lib/libm/common/m9x/__fex_sparc.c	2014-05-04 03:06:16.744172412 +0200
@@ -662,6 +662,9 @@
 			case fex_ldouble:
 				info->res.val.i = (int) info->res.val.q;
 				break;
+
+			default:
+				break;
 			}
 			*(int*)FPreg(rd) = info->res.val.i;
 			return;
@@ -685,6 +688,9 @@
 			case fex_ldouble:
 				info->res.val.l = (long long) info->res.val.q;
 				break;
+
+			default:
+				break;
 			}
 			*(long long*)FPREG(rd) = info->res.val.l;
 			break;
@@ -706,6 +712,9 @@
 			case fex_ldouble:
 				info->res.val.f = (float) info->res.val.q;
 				break;
+
+			default:
+				break;
 			}
 			*(float*)FPreg(rd) = info->res.val.f;
 			break;
@@ -727,6 +736,9 @@
 			case fex_ldouble:
 				info->res.val.d = (double) info->res.val.q;
 				break;
+
+			default:
+				break;
 			}
 			*(double*)FPREG(rd) = info->res.val.d;
 			break;
@@ -748,6 +760,9 @@
 			case fex_double:
 				info->res.val.q = (long double) info->res.val.d;
 				break;
+
+			default:
+				break;
 			}
 			*(long double*)FPREG(rd) = info->res.val.q;
 			break;
@@ -774,6 +789,9 @@
 			case fex_ldouble:
 				info->res.val.d = (double) info->res.val.q;
 				break;
+
+			default:
+				break;
 			}
 			*(double*)FPREG(rd) = info->res.val.d;
 			break;
@@ -795,6 +813,9 @@
 			case fex_double:
 				info->res.val.q = (long double) info->res.val.d;
 				break;
+
+			default:
+				break;
 			}
 			*(long double*)FPREG(rd) = info->res.val.q;
 			break;
@@ -820,6 +841,9 @@
 		case fex_ldouble:
 			info->res.val.f = (float) info->res.val.q;
 			break;
+
+		default:
+			break;
 		}
 		*(float*)FPreg(rd) = info->res.val.f;
 		break;
@@ -841,6 +865,9 @@
 		case fex_ldouble:
 			info->res.val.d = (double) info->res.val.q;
 			break;
+
+		default:
+			break;
 		}
 		*(double*)FPREG(rd) = info->res.val.d;
 		break;
@@ -862,6 +889,9 @@
 		case fex_double:
 			info->res.val.q = (long double) info->res.val.d;
 			break;
+
+		default:
+			break;
 		}
 		*(long double*)FPREG(rd) = info->res.val.q;
 		break;
--- old/usr/src/lib/libm/common/m9x/__fex_sse.c	2014-05-04 03:06:18.139734559 +0200
+++ new/usr/src/lib/libm/common/m9x/__fex_sse.c	2014-05-04 03:06:18.169694625 +0200
@@ -243,7 +243,7 @@
 			    fp_reg_set.fpchip_state.xmm[r];
 		}
 	} else if ((modrm & 0xc7) == 0x05) {
-#if defined(__amd64)
+#ifdef __amd64
 		/* address of next instruction + offset */
 		r = i + 4;
 		if (inst->op == cmpss || inst->op == cmpps ||
@@ -262,7 +262,7 @@
 			sib = ip[i++];
 			if ((sib & 7) == 5 && (modrm >> 6) == 0) {
 				/* start with absolute address */
-				addr = (char *)(uintptr_t)(ip + i);
+				addr = (char *)(uintptr_t)(*(int *)(ip + i));
 				i += 4;
 			} else {
 				/* start with base */
@@ -370,6 +370,8 @@
 	case cvttss2siq:
 	case cvttsd2siq:
 		return fex_inv_int;
+	default:
+		break;
 	}
 
 	/* check op1 for signaling nan */
@@ -411,6 +413,8 @@
 			return fex_inv_zdz;
 		if (t1 == fp_infinity && t2 == fp_infinity)
 			return fex_inv_idi;
+	default:
+		break;
 	}
 
 	return (enum fex_exception)-1;
@@ -638,6 +642,8 @@
 			info->res.type = fex_nodata;
 			sse_comisd(&info->op1.val.d, &info->op2.val.d);
 			break;
+		default:
+			break;
 		}
 	} else {
 		if (inst->op == cvtsi2ss) {
@@ -791,6 +797,8 @@
 			info->res.type = fex_nodata;
 			sse_comiss(&info->op1.val.f, &info->op2.val.f);
 			break;
+		default:
+			break;
 		}
 	}
 	__fenv_getmxcsr(&mxcsr);
@@ -1083,6 +1091,8 @@
 			dummy.op2 = (sseoperand_t *)&inst->op2->d[i];
 			e[i] = __fex_get_sse_op(uap, &dummy, &info[i]);
 		}
+	default:
+		break;
 	}
 }
 
@@ -1098,10 +1108,10 @@
 __fex_st_sse_result(ucontext_t *uap, sseinst_t *inst, enum fex_exception e,
     fex_info_t *info)
 {
-	int		i;
-	long long	l;
-	float		f, fscl;
-	double		d, dscl;
+	int		i = 0;
+	long long	l = 0L;;
+	float		f = 0.0, fscl;
+	double		d = 0.0L, dscl;
 
 	/* for compares that write eflags, just set the flags
 	   to indicate "unordered" */
@@ -1228,6 +1238,9 @@
 		case fex_ldouble:
 			i = info->res.val.q;
 			break;
+
+		default:
+			break;
 		}
 		inst->op1->i[0] = i;
 	} else if (inst->op == cmpsd || inst->op == cvttss2siq ||
@@ -1253,6 +1266,9 @@
 		case fex_ldouble:
 			l = info->res.val.q;
 			break;
+
+		default:
+			break;
 		}
 		inst->op1->l[0] = l;
 	} else if ((((int)inst->op & DOUBLE) && inst->op != cvtsd2ss) ||
@@ -1277,6 +1293,9 @@
 		case fex_ldouble:
 			d = info->res.val.q;
 			break;
+
+		default:
+			break;
 		}
 		inst->op1->d[0] = d;
 	} else {
@@ -1300,6 +1319,9 @@
 		case fex_ldouble:
 			f = info->res.val.q;
 			break;
+
+		default:
+			break;
 		}
 		inst->op1->f[0] = f;
 	}
@@ -1578,5 +1600,9 @@
 		}
 		/* zero the high 64 bits of the destination */
 		inst->op1->l[1] = 0ll;
+
+	default:
+		break;
 	}
 }
+
--- old/usr/src/lib/libm/common/m9x/fdim.c	2014-05-04 03:06:20.170474739 +0200
+++ new/usr/src/lib/libm/common/m9x/fdim.c	2014-05-04 03:06:20.199273295 +0200
@@ -44,11 +44,7 @@
 
 double
 __fdim(double x, double y) {
-#if defined(COMPARISON_MACRO_BUG)
-	if (x == x && y == y && x <= y) {	/* } */
-#else
 	if (islessequal(x, y)) {
-#endif
 		x = 0.0;
 		y = -x;
 	}
--- old/usr/src/lib/libm/common/m9x/fdimf.c	2014-05-04 03:06:21.900546712 +0200
+++ new/usr/src/lib/libm/common/m9x/fdimf.c	2014-05-04 03:06:21.930736164 +0200
@@ -47,11 +47,7 @@
 	 * fmovsle	%fcc0,%f3,%f1
 	 * fsubs	%f0,%f1,%f0
 	 */
-#if defined(COMPARISON_MACRO_BUG)
-	if (x == x && y == y && x <= y) {	/* } */
-#else
 	if (islessequal(x, y)) {
-#endif
 		x = 0.0f;
 		y = -x;
 	}
--- old/usr/src/lib/libm/common/m9x/fdiml.c	2014-05-04 03:06:23.475611153 +0200
+++ new/usr/src/lib/libm/common/m9x/fdiml.c	2014-05-04 03:06:23.499163732 +0200
@@ -35,11 +35,7 @@
 
 long double
 __fdiml(long double x, long double y) {
-#if defined(COMPARISON_MACRO_BUG)
-	if (x == x && y == y && x <= y) {
-#else
 	if (islessequal(x, y)) {
-#endif
 		x = 0.0l;
 		y = -x;
 	}
--- old/usr/src/lib/libm/common/m9x/fenv_inlines.h	2014-05-04 03:06:24.742450005 +0200
+++ new/usr/src/lib/libm/common/m9x/fenv_inlines.h	2014-05-04 03:06:24.772096466 +0200
@@ -42,13 +42,12 @@
 extern __inline__ void
 __fenv_getcwsw(unsigned int *value)
 {
-	union fp_cwsw ret;
+	union fp_cwsw *u = (union fp_cwsw *)value;
 
 	__asm__ __volatile__(
 	    "fstsw %0\n\t"
 	    "fstcw %1\n\t"
-	    : "=m" (ret.words.cw), "=m" (ret.words.sw));
-	*value = ret.cwsw;
+	    : "=m" (u->words.cw), "=m" (u->words.sw));
 }
 
 extern __inline__ void
@@ -66,7 +65,7 @@
 	    "fldenv %0\n\t"
 	    "fwait\n\t"
 	    : "=m" (fenv), "=m" (fenv[0]), "=m" (fenv[2])
-	    : "d" (cwsw.words.cw), "c" (cwsw.words.sw)
+	    : "r" (cwsw.words.cw), "r" (cwsw.words.sw)
 	    /* For practical purposes, we clobber the whole FPU */
 	    : "cc", "st", "st(1)", "st(2)", "st(3)", "st(4)", "st(5)",
 	      "st(6)", "st(7)");
@@ -75,7 +74,7 @@
 extern __inline__ void
 __fenv_getmxcsr(unsigned int *value)
 {
-	__asm__ __volatile__("stmxcsr %1" : "+m" (*value));
+	__asm__ __volatile__("stmxcsr %0" : "=m" (*value));
 }
 
 extern __inline__ void
@@ -89,7 +88,7 @@
 {
 	long double ret;
 
-	__asm__ __volatile__("f2xm1" : "=t" (ret) : "0" (x));
+	__asm__ __volatile__("f2xm1" : "=t" (ret) : "0" (x) : "cc");
 	return (ret);
 }
 
@@ -98,7 +97,10 @@
 {
 	long double ret;
 
-	__asm__ __volatile__("fyl2x" : "=t" (ret): "0" (x), "u" (y) : "st(1)");
+	__asm__ __volatile__("fyl2x"
+	    : "=t" (ret)
+	    : "0" (x), "u" (y)
+	    : "st(1)", "cc");
 	return (ret);
 }
 
@@ -112,7 +114,10 @@
 	long double ret;
 	long double dummy;
 
-	__asm__ __volatile__("fptan" : "=t" (dummy), "=u" (ret) : "0" (x));
+	__asm__ __volatile__("fptan"
+	    : "=t" (dummy), "=u" (ret)
+	    : "0" (x)
+	    : "cc");
 	return (ret);
 }
 
@@ -124,35 +129,29 @@
 	__asm__ __volatile__("fpatan"
 	    : "=t" (ret)
 	    : "0" (y), "u" (x)
-	    : "st(1)");
+	    : "st(1)", "cc");
 	return (ret);
 }
 
 extern __inline__ long double
 fxtract(long double x)
 {
-	long double ret;
-
-	__asm__ __volatile__("fxtract" : "=t" (ret) : "0" (x));
-	return (ret);
+	__asm__ __volatile__("fxtract" : "+t" (x) : : "cc");
+	return (x);
 }
 
 extern __inline__ long double
 fprem1(long double idend, long double div)
 {
-	long double ret;
-
-	__asm__ __volatile__("fprem1" : "=t" (ret) : "0" (div), "u" (idend));
-	return (ret);
+	__asm__ __volatile__("fprem1" : "+t" (div) : "u" (idend) : "cc");
+	return (div);
 }
 
 extern __inline__ long double
 fprem(long double idend, long double div)
 {
-	long double ret;
-
-	__asm__ __volatile__("fprem" : "=t" (ret) : "0" (div), "u" (idend));
-	return (ret);
+	__asm__ __volatile__("fprem" : "+t" (div) : "u" (idend) : "cc");
+	return (div);
 }
 
 extern __inline__ long double
@@ -163,35 +162,29 @@
 	__asm__ __volatile__("fyl2xp1"
 	    : "=t" (ret)
 	    : "0" (x), "u" (y)
-	    : "st(1)");
+	    : "st(1)", "cc");
 	return (ret);
 }
 
 extern __inline__ long double
 fsqrt(long double x)
 {
-	long double ret;
-
-	__asm__ __volatile__("fsqrt" : "=t" (ret) : "0" (x));
-	return (ret);
+	__asm__ __volatile__("fsqrt" : "+t" (x) : : "cc");
+	return (x);
 }
 
 extern __inline__ long double
 fsincos(long double x)
 {
-	long double ret;
-
-	__asm__ __volatile__("fsincos" : "=t" (ret) : "0" (x));
-	return (ret);
+	__asm__ __volatile__("fsincos" : "+t" (x) : : "cc");
+	return (x);
 }
 
 extern __inline__ long double
 frndint(long double x)
 {
-	long double ret;
-
-	__asm__ __volatile__("frndint" : "=t" (ret) : "0" (x));
-	return (ret);
+	__asm__ __volatile__("frndint" : "+t" (x) : : "cc");
+	return (x);
 }
 
 extern __inline__ long double
@@ -199,26 +192,22 @@
 {
 	long double ret;
 
-	__asm__ __volatile__("fscale" : "=t" (ret) : "0" (y), "u" (x));
+	__asm__ __volatile__("fscale" : "=t" (ret) : "0" (y), "u" (x) : "cc");
 	return (ret);
 }
 
 extern __inline__ long double
 fsin(long double x)
 {
-	long double ret;
-
-	__asm__ __volatile__("fsin" : "=t" (ret) : "0" (x));
-	return (ret);
+	__asm__ __volatile__("fsin" : "+t" (x) : : "cc");
+	return (x);
 }
 
 extern __inline__ long double
 fcos(long double x)
 {
-	long double ret;
-
-	__asm__ __volatile__("fcos" : "=t" (ret) : "0" (x));
-	return (ret);
+	__asm__ __volatile__("fcos" : "+t" (x) : : "cc");
+	return (x);
 }
 
 extern __inline__ void
@@ -227,8 +216,9 @@
 	__asm__ __volatile__(
 	    "cmpeqss %2, %1\n\t"
 	    "movss   %1, %0"
-	    : "=m" (*i1)
-	    : "x" (*f1), "x" (*f2));
+	    : "=m" (*i1), "+x" (*f1)
+	    : "x" (*f2)
+	    : "cc");
 }
 
 extern __inline__ void
@@ -237,8 +227,9 @@
 	__asm__ __volatile__(
 	    "cmpltss %2, %1\n\t"
 	    "movss   %1, %0"
-	    : "=m" (*i1)
-	    : "x" (*f1), "x" (*f2));
+	    : "=m" (*i1), "+x" (*f1)
+	    : "x" (*f2)
+	    : "cc");
 }
 
 extern __inline__ void
@@ -247,8 +238,9 @@
 	__asm__ __volatile__(
 	    "cmpless %2, %1\n\t"
 	    "movss   %1, %0"
-	    : "=m" (*i1)
-	    : "x" (*f1), "x" (*f2));
+	    : "=m" (*i1), "+x" (*f1)
+	    : "x" (*f2)
+	    : "cc");
 }
 
 extern __inline__ void
@@ -257,8 +249,9 @@
 	__asm__ __volatile__(
 	    "cmpunordss %2, %1\n\t"
 	    "movss      %1, %0"
-	    : "=m" (*i1)
-	    : "x" (*f1), "x" (*f2));
+	    : "=m" (*i1), "+x" (*f1)
+	    : "x" (*f2)
+	    : "cc");
 }
 
 extern __inline__ void
@@ -267,8 +260,8 @@
 	__asm__ __volatile__(
 	    "minss %2, %1\n\t"
 	    "movss %1, %0"
-	    : "=m" (*f3)
-	    : "x" (*f1), "x" (*f2));
+	    : "=m" (*f3), "+x" (*f1)
+	    : "x" (*f2));
 }
 
 extern __inline__ void
@@ -277,8 +270,8 @@
 	__asm__ __volatile__(
 	    "maxss %2, %1\n\t"
 	    "movss %1, %0"
-	    : "=m" (*f3)
-	    : "x" (*f1), "x" (*f2));
+	    : "=m" (*f3), "+x" (*f1)
+	    : "x" (*f2));
 }
 
 extern __inline__ void
@@ -287,8 +280,8 @@
 	__asm__ __volatile__(
 	    "addss %2, %1\n\t"
 	    "movss %1, %0"
-	    : "=m" (*f3)
-	    : "x" (*f1), "x" (*f2));
+	    : "=m" (*f3), "+x" (*f1)
+	    : "x" (*f2));
 }
 
 extern __inline__ void
@@ -297,8 +290,8 @@
 	__asm__ __volatile__(
 	    "subss %2, %1\n\t"
 	    "movss %1, %0"
-	    : "=m" (*f3)
-	    : "x" (*f1), "x" (*f2));
+	    : "=m" (*f3), "+x" (*f1)
+	    : "x" (*f2));
 }
 
 extern __inline__ void
@@ -307,8 +300,8 @@
 	__asm__ __volatile__(
 	    "mulss %2, %1\n\t"
 	    "movss %1, %0"
-	    : "=m" (*f3)
-	    : "x" (*f1), "x" (*f2));
+	    : "=m" (*f3), "+x" (*f1)
+	    : "x" (*f2));
 }
 
 extern __inline__ void
@@ -317,19 +310,20 @@
 	__asm__ __volatile__(
 	    "divss %2, %1\n\t"
 	    "movss %1, %0"
-	    : "=m" (*f3)
-	    : "x" (*f1), "x" (*f2));
+	    : "=m" (*f3), "+x" (*f1)
+	    : "x" (*f2));
 }
 
 extern __inline__ void
 sse_sqrtss(float *f1, float *f2)
 {
+	double tmp;
+
 	__asm__ __volatile__(
-	    "sqrtss %1, %%xmm0\n\t"
-	    "movss  %%xmm0, %0"
-	    : "=m" (*f2)
-	    : "m" (*f1)
-	    : "xmm0");
+	    "sqrtss %2, %1\n\t"
+	    "movss  %1, %0"
+	    : "=m" (*f2), "=x" (tmp)
+	    : "m" (*f1));
 }
 
 extern __inline__ void
@@ -348,79 +342,86 @@
 extern __inline__ void
 sse_cvtss2sd(float *f1, double *d1)
 {
+	double tmp;
+
 	__asm__ __volatile__(
-	    "cvtss2sd %1, %%xmm0\n\t"
-	    "movsd    %%xmm0, %0"
-	    : "=m" (*d1)
-	    : "m" (*f1)
-	    : "xmm0");
+	    "cvtss2sd %2, %1\n\t"
+	    "movsd    %1, %0"
+	    : "=m" (*d1), "=x" (tmp)
+	    : "m" (*f1));
 }
 
 extern __inline__ void
 sse_cvtsi2ss(int *i1, float *f1)
 {
+	double tmp;
+
 	__asm__ __volatile__(
-	    "cvtsi2ss %1, %%xmm0\n\t"
-	    "movss    %%xmm0, %0"
-	    : "=m" (*f1)
-	    : "m" (*i1)
-	    : "xmm0");
+	    "cvtsi2ss %2, %1\n\t"
+	    "movss    %1, %0"
+	    : "=m" (*f1), "=x" (tmp)
+	    : "m" (*i1));
 }
 
 extern __inline__ void
 sse_cvttss2si(float *f1, int *i1)
 {
+	int tmp;
+
 	__asm__ __volatile__(
-	    "cvttss2si %1, %%ecx\n\t"
-	    "movl      %%ecx, %0"
-	    : "=m" (*i1)
-	    : "m" (*f1)
-	    : "ecx");
+	    "cvttss2si %2, %1\n\t"
+	    "movl      %1, %0"
+	    : "=m" (*i1), "=r" (tmp)
+	    : "m" (*f1));
 }
 
 extern __inline__ void
 sse_cvtss2si(float *f1, int *i1)
 {
+	int tmp;
+
 	__asm__ __volatile__(
-	    "cvtss2si %1, %%ecx\n\t"
-	    "movl     %%ecx, %0"
-	    : "=m" (*i1)
-	    : "m" (*f1)
-	    : "ecx");
+	    "cvtss2si %2, %1\n\t"
+	    "movl     %1, %0"
+	    : "=m" (*i1), "=r" (tmp)
+	    : "m" (*f1));
 }
 
 #if defined(__amd64)
 extern __inline__ void
 sse_cvtsi2ssq(long long *ll1, float *f1)
 {
+	double tmp;
+
 	__asm__ __volatile__(
-	    "cvtsi2ssq %1, %%xmm0\n\t"
-	    "movss     %%xmm0, %0"
-	    : "=m" (*f1)
-	    : "m" (*ll1)
-	    : "xmm0");
+	    "cvtsi2ssq %2, %1\n\t"
+	    "movss     %1, %0"
+	    : "=m" (*f1), "=x" (tmp)
+	    : "m" (*ll1));
 }
 
 extern __inline__ void
 sse_cvttss2siq(float *f1, long long *ll1)
 {
+	uint64_t tmp;
+
 	__asm__ __volatile__(
-	    "cvttss2siq %1, %%rcx\n\t"
-	    "movq       %%rcx, %0"
-	    : "=m" (*ll1)
-	    : "m" (*f1)
-	    : "rcx");
+	    "cvttss2siq %2, %1\n\t"
+	    "movq       %1, %0"
+	    : "=m" (*ll1), "=r" (tmp)
+	    : "m" (*f1));
 }
 
 extern __inline__ void
 sse_cvtss2siq(float *f1, long long *ll1)
 {
+	uint64_t tmp;
+
 	__asm__ __volatile__(
-	    "cvtss2siq %1, %%rcx\n\t"
-	    "movq      %%rcx, %0"
-	    : "=m" (*ll1)
-	    : "m" (*f1)
-	    : "rcx");
+	    "cvtss2siq %2, %1\n\t"
+	    "movq      %1, %0"
+	    : "=m" (*ll1), "=r" (tmp)
+	    : "m" (*f1));
 }
 
 #endif
@@ -431,8 +432,8 @@
 	__asm__ __volatile__(
 	    "cmpeqsd %2,%1\n\t"
 	    "movsd   %1,%0"
-	    : "=m" (*ll1)
-	    : "x" (*d1), "x" (*d2));
+	    : "=m" (*ll1), "=x" (*d1)
+	    : "x" (*d2));
 }
 
 extern __inline__ void
@@ -441,8 +442,8 @@
 	__asm__ __volatile__(
 	    "cmpltsd %2,%1\n\t"
 	    "movsd   %1,%0"
-	    : "=m" (*ll1)
-	    : "x" (*d1), "x" (*d2));
+	    : "=m" (*ll1), "=x" (*d1)
+	    : "x" (*d2));
 }
 
 extern __inline__ void
@@ -451,8 +452,8 @@
 	__asm__ __volatile__(
 	    "cmplesd %2,%1\n\t"
 	    "movsd   %1,%0"
-	    : "=m" (*ll1)
-	    : "x" (*d1), "x" (*d2));
+	    : "=m" (*ll1), "=x" (*d1)
+	    : "x" (*d2));
 }
 
 extern __inline__ void
@@ -461,8 +462,8 @@
 	__asm__ __volatile__(
 	    "cmpunordsd %2,%1\n\t"
 	    "movsd      %1,%0"
-	    : "=m" (*ll1)
-	    : "x" (*d1), "x" (*d2));
+	    : "=m" (*ll1), "=x" (*d1)
+	    : "x" (*d2));
 }
 
 
@@ -472,8 +473,8 @@
 	__asm__ __volatile__(
 	    "minsd %2,%1\n\t"
 	    "movsd %1,%0"
-	    : "=m" (*d3)
-	    : "x" (*d1), "x" (*d2));
+	    : "=m" (*d3), "=x" (*d1)
+	    : "x" (*d2));
 }
 
 extern __inline__ void
@@ -482,8 +483,8 @@
 	__asm__ __volatile__(
 	    "maxsd %2,%1\n\t"
 	    "movsd %1,%0"
-	    : "=m" (*d3)
-	    : "x" (*d1), "x" (*d2));
+	    : "=m" (*d3), "=x" (*d1)
+	    : "x" (*d2));
 }
 
 extern __inline__ void
@@ -492,8 +493,8 @@
 	__asm__ __volatile__(
 	    "addsd %2,%1\n\t"
 	    "movsd %1,%0"
-	    : "=m" (*d3)
-	    : "x" (*d1), "x" (*d2));
+	    : "=m" (*d3), "=x" (*d1)
+	    : "x" (*d2));
 }
 
 extern __inline__ void
@@ -502,8 +503,8 @@
 	__asm__ __volatile__(
 	    "subsd %2,%1\n\t"
 	    "movsd %1,%0"
-	    : "=m" (*d3)
-	    : "x" (*d1), "x" (*d2));
+	    : "=m" (*d3), "=x" (*d1)
+	    : "x" (*d2));
 }
 
 extern __inline__ void
@@ -512,8 +513,8 @@
 	__asm__ __volatile__(
 	    "mulsd %2,%1\n\t"
 	    "movsd %1,%0"
-	    : "=m" (*d3)
-	    : "x" (*d1), "x" (*d2));
+	    : "=m" (*d3), "=x" (*d1)
+	    : "x" (*d2));
 }
 
 extern __inline__ void
@@ -522,20 +523,20 @@
 	__asm__ __volatile__(
 	    "divsd %2,%1\n\t"
 	    "movsd %1,%0"
-	    : "=m" (*d3)
-	    : "x" (*d1), "x" (*d2)
-	    : "xmm0");
+	    : "=m" (*d3), "=x" (*d1)
+	    : "x" (*d2));
 }
 
 extern __inline__ void
 sse_sqrtsd(double *d1, double *d2)
 {
+	double tmp;
+
 	__asm__ __volatile__(
-	    "sqrtsd %1, %%xmm0\n\t"
-	    "movsd %%xmm0, %0"
-	    : "=m" (*d2)
-	    : "m" (*d1)
-	    : "xmm0");
+	    "sqrtsd %2, %1\n\t"
+	    "movsd %1, %0"
+	    : "=m" (*d2), "=x" (tmp)
+	    : "m" (*d1));
 }
 
 extern __inline__ void
@@ -553,117 +554,123 @@
 extern __inline__ void
 sse_cvtsd2ss(double *d1, float *f1)
 {
+	double tmp;
+
 	__asm__ __volatile__(
-	    "cvtsd2ss %1,%%xmm0\n\t"
-	    "movss    %%xmm0,%0"
-	    : "=m" (*f1)
-	    : "m" (*d1)
-	    : "xmm0");
+	    "cvtsd2ss %2,%1\n\t"
+	    "movss    %1,%0"
+	    : "=m" (*f1), "=x" (tmp)
+	    : "m" (*d1));
 }
 
-
 extern __inline__ void
 sse_cvtsi2sd(int *i1, double *d1)
 {
+	double tmp;
 	__asm__ __volatile__(
-	    "cvtsi2sd %1,%%xmm0\n\t"
-	    "movsd    %%xmm0,%0"
-	    : "=m" (*d1)
-	    : "m" (*i1)
-	    : "xmm0");
+	    "cvtsi2sd %2,%1\n\t"
+	    "movsd    %1,%0"
+	    : "=m" (*d1), "=x" (tmp)
+	    : "m" (*i1));
 }
 
 extern __inline__ void
 sse_cvttsd2si(double *d1, int *i1)
 {
+	int tmp;
+
 	__asm__ __volatile__(
-	    "cvttsd2si %1,%%ecx\n\t"
-	    "movl      %%ecx,%0"
-	    : "=m" (*i1)
-	    : "m" (*d1)
-	    : "ecx");
+	    "cvttsd2si %2,%1\n\t"
+	    "movl      %1,%0"
+	    : "=m" (*i1), "=r" (tmp)
+	    : "m" (*d1));
 }
 
 extern __inline__ void
 sse_cvtsd2si(double *d1, int *i1)
 {
+	int tmp;
+
 	__asm__ __volatile__(
-	    "cvtsd2si %1,%%ecx\n\t"
-	    "movl     %%ecx,%0"
-	    : "=m" (*i1)
-	    : "m" (*d1)
-	    : "ecx");
+	    "cvtsd2si %2,%1\n\t"
+	    "movl     %1,%0"
+	    : "=m" (*i1), "=r" (tmp)
+	    : "m" (*d1));
 }
 
 #if defined(__amd64)
 extern __inline__ void
 sse_cvtsi2sdq(long long *ll1, double *d1)
 {
+	double tmp;
+
 	__asm__ __volatile__(
-	    "cvtsi2sdq %1,%%xmm0\n\t"
-	    "movsd     %%xmm0,%0"
-	    : "=m" (*d1)
-	    : "m" (*ll1)
-	    : "xmm0");
+	    "cvtsi2sdq %2,%1\n\t"
+	    "movsd     %1,%0"
+	    : "=m" (*d1), "=x" (tmp)
+	    : "m" (*ll1));
 }
 
 extern __inline__ void
 sse_cvttsd2siq(double *d1, long long *ll1)
 {
+	uint64_t tmp;
+
 	__asm__ __volatile__(
-	    "cvttsd2siq %1,%%rcx\n\t"
-	    "movq       %%rcx,%0"
-	    : "=m" (*ll1)
-	    : "m" (*d1)
-	    : "rcx");
+	    "cvttsd2siq %2,%1\n\t"
+	    "movq       %1,%0"
+	    : "=m" (*ll1), "=r" (tmp)
+	    : "m" (*d1));
 }
 
 extern __inline__ void
 sse_cvtsd2siq(double *d1, long long *ll1)
 {
+	uint64_t tmp;
+
 	__asm__ __volatile__(
-	    "cvtsd2siq %1,%%rcx\n\t"
-	    "movq      %%rcx,%0"
-	    : "=m" (*ll1)
-	    : "m" (*d1)
-	    : "rcx");
+	    "cvtsd2siq %2,%1\n\t"
+	    "movq      %1,%0"
+	    : "=m" (*ll1), "=r" (tmp)
+	    : "m" (*d1));
 }
 #endif
+
 #elif defined(__sparc)
 extern __inline__ void
 __fenv_getfsr(unsigned long *l)
 {
-    __asm__ __volatile__(
+	__asm__ __volatile__(
 #if defined(__sparcv9)
-        "stx %%fsr,%0\n\t"
+		"stx %%fsr,%0\n\t"
 #else
-        "st  %%fsr,%0\n\t"
+		"st  %%fsr,%0\n\t"
 #endif
-        : "=m" (*l));
+		: "=m" (*l));
 }
 
 extern __inline__ void
 __fenv_setfsr(const unsigned long *l)
 {
-    __asm__ __volatile__(
+	__asm__ __volatile__(
 #if defined(__sparcv9)
-        "ldx %0,%%fsr\n\t"
+		"ldx %0,%%fsr\n\t"
 #else
-        "ld %0,%%fsr\n\t"
+		"ld %0,%%fsr\n\t"
 #endif
-        : : "m" (*l));
+		: : "m" (*l) : "cc");
 }
 
 extern __inline__ void
 __fenv_getfsr32(unsigned int *l)
 {
-    __asm__ __volatile__("st %%fsr,%0\n\t" : "=m" (*l));
+	__asm__ __volatile__("st %%fsr,%0\n\t" : "=m" (*l));
 }
 
 extern __inline__ void
 __fenv_setfsr32(const unsigned int *l)
 {
-    __asm__ __volatile__("ld %0,%%fsr\n\t" : : "m" (*l));
+	__asm__ __volatile__("ld %0,%%fsr\n\t" : : "m" (*l));
 }
 #else
 #error "GCC FENV inlines not implemented for this platform"
--- old/usr/src/lib/libm/common/m9x/fex_handler.h	2014-05-04 03:06:27.198496344 +0200
+++ new/usr/src/lib/libm/common/m9x/fex_handler.h	2014-05-04 03:06:27.213078526 +0200
@@ -27,8 +27,6 @@
  * Use is subject to license terms.
  */
 
-/* #include <sys/isa_defs.h> */
-
 /* the following enums must match the bit positions in fenv.h */
 enum fex_exception {
 	fex_inexact		= 0,
@@ -65,7 +63,7 @@
 
 /* inline templates and macros for accessing fp state */
 extern void __fenv_getfsr(unsigned long *);
-extern void __fenv_setfsr(unsigned const long *);
+extern void __fenv_setfsr(const unsigned long *);
 
 #if defined(__sparc)
 
--- old/usr/src/lib/libm/common/m9x/fex_log.c	2014-05-04 03:06:29.486287752 +0200
+++ new/usr/src/lib/libm/common/m9x/fex_log.c	2014-05-04 03:06:29.515834354 +0200
@@ -122,7 +122,7 @@
 static int check_exc_list(char *addr, unsigned long code, char *stk,
     struct frame *fp)
 {
-	struct exc_list	*l, *ll;
+	struct exc_list	*l, *ll = NULL;
 	struct frame	*f;
 	int		i, n;
 
--- old/usr/src/lib/libm/common/m9x/fma.c	2014-05-04 03:06:31.227196182 +0200
+++ new/usr/src/lib/libm/common/m9x/fma.c	2014-05-04 03:06:31.253623706 +0200
@@ -76,8 +76,7 @@
 		double d;
 	} xx, yy, zz;
 	double xhi, yhi, xlo, ylo, t;
-	unsigned xy0, xy1, xy2, xy3, z0, z1, z2, z3, rm, sticky;
-	unsigned int fsr;
+	unsigned int xy0, xy1, xy2, xy3, z0, z1, z2, z3, fsr, rm, sticky;
 	int hx, hy, hz, ex, ey, ez, exy, sxy, sz, e, ibit;
 	volatile double	dummy;
 
@@ -493,119 +492,6 @@
 	return ((double) yy.e);
 }
 
-#if 0
-/*
- * another fma for x86: assumes return value will be left in
- * long double (80-bit double extended) precision
- */
-long double
-__fma(double x, double y, double z) {
-	union {
-		unsigned i[3];
-		long double e;
-	} xx, yy, zz, tt;
-	long double xe, ye, xhi, xlo, yhi, ylo, zhi, zlo;
-	int ex, ey, ez;
-	unsigned cwsw, oldcwsw, s;
-
-	/* convert the operands to double extended */
-	xx.e = (long double) x;
-	yy.e = (long double) y;
-	zz.e = (long double) z;
-
-	/* extract the exponents of the arguments */
-	ex = xx.i[2] & 0x7fff;
-	ey = yy.i[2] & 0x7fff;
-	ez = zz.i[2] & 0x7fff;
-
-	/* dispense with inf, nan, and zero cases */
-	if (ex == 0x7fff || ey == 0x7fff || ex == 0 || ey == 0)
-		/* x or y is inf, nan, or zero */
-		return (xx.e * yy.e + zz.e);
-
-	if (ez >= 0x7fff) /* z is inf or nan */
-		return (xx.e + zz.e);	/* avoid spurious inexact in x * y */
-
-	if (ez == 0) /* z is zero */
-		return (xx.e * yy.e);	/* x * y isn't zero; no need to add z */
-
-	/*
-	 * save the control and status words, mask all exceptions, and
-	 * set rounding to 64-bit precision and to-nearest
-	 */
-	__fenv_getcwsw(&oldcwsw);
-	cwsw = (oldcwsw & 0xf0c0ffff) | 0x033f0000;
-	__fenv_setcwsw(&cwsw);
-
-	/* multiply x*y to 106 bits */
-	xe = xx.e;
-	xx.i[0] = 0;
-	xhi = xx.e; /* hi 32 bits */
-	xlo = xe - xhi; /* lo 21 bits */
-	ye = yy.e;
-	yy.i[0] = 0;
-	yhi = yy.e;
-	ylo = ye - yhi;
-	xx.e = xe * ye;
-	xx.i[0] &= ~0x7ff; /* 53 bits of x*y */
-	yy.e = ((xhi * yhi - xx.e) + xhi * ylo + xlo * yhi) + xlo * ylo;
-
-	/* reduce to a sum of two terms */
-	if (yy.e != 0.0) {
-		ex = xx.i[2] & 0x7fff;
-		if (ez - ex > 10) {
-			/* collapse y into a single bit and add to x */
-			yy.i[0] = 0;
-			yy.i[1] = 0x80000000;
-			yy.i[2] = (yy.i[2] & 0x8000) | (ex - 60);
-			xx.e += yy.e;
-		} else if (ex - ez <= 10) {
-			xx.e += zz.e; /* exact */
-			zz.e = yy.e;
-		} else if (ex - ez <= 42) {
-			/* split z into two pieces */
-			tt.i[0] = 0;
-			tt.i[1] = 0x80000000;
-			tt.i[2] = ex + 11;
-			zhi = (zz.e + tt.e) - tt.e;
-			zlo = zz.e - zhi;
-			xx.e += zhi;
-			zz.e = yy.e + zlo;
-		} else if (ex - ez <= 63) {
-			zz.e += yy.e; /* exact */
-		} else if (ex - ez <= 106) {
-			/*
-			 * collapse the tail of z into a sticky bit and add z
-			 * to y without error
-			 */
-			if (ex - ez <= 81) {
-				s = 1 << (ex - ez - 50);
-				if (zz.i[0] & (s - 1))
-					zz.i[0] |= s;
-				zz.i[0] &= ~(s - 1);
-			} else {
-				s = 1 << (ex - ez - 82);
-				if ((zz.i[1] & (s - 1)) | zz.i[0])
-					zz.i[1] |= s;
-				zz.i[1] &= ~(s - 1);
-				zz.i[0] = 0;
-			}
-			zz.e += yy.e;
-		} else {
-			/* collapse z into a single bit and add to y */
-			zz.i[0] = 0;
-			zz.i[1] = 0x80000000;
-			zz.i[2] = (zz.i[2] & 0x8000) | (ex - 113);
-			zz.e += yy.e;
-		}
-	}
-
-	/* restore the control and status words, and sum */
-	__fenv_setcwsw(&oldcwsw);
-	return (xx.e + zz.e);
-}
-#endif
-
 #else
 #error Unknown architecture
 #endif
--- old/usr/src/lib/libm/common/m9x/fmal.c	2014-05-04 03:06:33.619621690 +0200
+++ new/usr/src/lib/libm/common/m9x/fmal.c	2014-05-04 03:06:33.649887126 +0200
@@ -84,17 +84,17 @@
 long double
 __fmal(long double x, long double y, long double z) {
 	union {
-		unsigned i[4];
+		unsigned int i[4];
 		long double q;
 	} xx, yy, zz;
 	union {
-		unsigned i[2];
+		unsigned int i[2];
 		double d;
 	} u;
 	double dx[5], dy[5], dxy[9], c, s;
-	unsigned xy0, xy1, xy2, xy3, xy4, xy5, xy6, xy7;
-	unsigned z0, z1, z2, z3, z4, z5, z6, z7;
-	unsigned rm, sticky;
+	unsigned int xy0, xy1, xy2, xy3, xy4, xy5, xy6, xy7;
+	unsigned int z0, z1, z2, z3, z4, z5, z6, z7;
+	unsigned int rm, sticky;
 	unsigned int fsr;
 	int hx, hy, hz, ex, ey, ez, exy, sxy, sz, e, ibit;
 	int cx, cy, cz;
